﻿-------------------------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}
local helper = require('scenario/scenariohelper')
--local vdata = {}  -- Current ai vehicle data
--local tdata = {}  --Target data

local user = "Hawk"
local target = nil
local targetSet = false
local hitTarget =  false
local vName = nil
local lasthit = false
local backup = false
local brake = 0
local throttle = 0
local collision = false
local tdataPos = nil
local callReset = false

require('mathlib')
local function debug(aiDirVec, targetAiMidPos, targetLength, dt)
	--if test2 ~= nil then
	--	debugDrawer:drawSphere(test2:toPoint3F(), 4, ColorF(1,0,0,0.3))
	--end
	--local debugDrawer = obj.debugDrawProxy
	local vel = map.objects[map.objectNames[vName]].vel
	local tpos = map.objects[map.objectNames[target]].pos
	local pos = map.objects[map.objectNames[vName]].pos
	if tpos ~= nil and targetAiMidPos ~= nil then
		--debugDrawer:drawSphere(test:toPoint3F(), 1.5, ColorF(1,0,0,0.3))
	local speed = vel:length()
	if speed < 3 then
		speed = 2 
	else 
		speed = 1 
	end

	local tspeed = vel:length()
	
	local futurePos = pos + (vel):normalized() * speed
	local futureTarget = tpos +  ((vel:normalized()) * tspeed)
	local futurePos2 = pos + vel * speed
	--debugDrawer:drawSphere(futurePos:toPoint3F(), 0.5, ColorF(1,0,0,0.3))
	--debugDrawer:drawSphere(futureTarget:toPoint3F(), 0.5, ColorF(0,1,0,1))
	debugDrawer:drawSphere(futurePos2:toPoint3F(), 0.5, ColorF(1,1,0,1))
    --debugDrawer:drawSphere((aiDirVec*targetLength + futureTarget):toPoint3F(), 0.5, ColorF(0,1,0,1))
   -- debugDrawer:drawSphere(targetAiMidPos:toPoint3F(), 0.3, ColorF(1,0,0,0.3))
	end
end
-------------------------------------------------------------------------------------
--RETURNS A TARGET FOR THE AI  *vNotToTarget - set AI to not target itself
-------------------------------------------------------------------------------------
local function findRandomTarget(vNotToTarget)
	local sVehicles = scenario_derby_vehicles.sVehicles
	local vehIn = scenario_derby_main.vehIn
	local vTimeout = scenario_derby_main.vTimeout
	local targetList = {}
	local dirVec = map.objects[map.objectNames[vNotToTarget]].dirVec
	local pos = map.objects[map.objectNames[vNotToTarget]].pos
	local bestTargetVec = 0
	local lastbest = {}
	local far = 0
	local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount
	if cCount < 1 then
		--for i = 0, 3 do
			local point = scenario_derby_util.findRandomPoint()
			local tDist = vec3(pos):distance(vec3(point))
			if tDist > 20 then
				scenario_derby_vehicles.vehicleData[vNotToTarget].targetObj = point
				target = "point"
				cCount = cCount + 1
				scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount
				--print(vNotToTarget .. " point")
				--break
			end
			--i = i + 1
		--end
		if target ~= "point" then
			--print("1")
			if not vTimeout[user] then
				target = user 
			else 
				--print("2")
				for k, vList in pairs(sVehicles) do
					if vList ~= vNotToTarget and not vTimeout[vList] then
						table.insert(targetList, vList)
					end			
				end
				local j = tableChooseRandomKey(targetList)
				target = targetList[j]
			end
			--print(vNotToTarget.. " " .. target .. "far")
		end
	else
		for k, vList in pairs(sVehicles) do
			if vList ~= vNotToTarget and not vTimeout[vList] then
			--if vehIn > 2 then
				--if scenario_derby_main.stopTicks[vName] < 100 then 
					local vObj = scenetree.findObject(vList)
					if vObj then
						local position =  vObj:getPosition()
						local targetVec = (vec3(position) - vec3(pos)):normalized()
						local i = math.abs(dirVec:dot(targetVec))
						lastbest[vList] = i	
						if i >= bestTargetVec then	
							bestTargetVec = i
						end
					end
				--end
			--else
			--	table.insert(targetList, vName)
			--end
			end
		end
		--dump(lastbest)
		for vList, i in pairs(lastbest) do
			if i == bestTargetVec then  
				table.insert(targetList, vList)
			end
		end
		local j = tableChooseRandomKey(targetList)
		target = targetList[j]	
	end
	--local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount 
	--if cCount < 1 then
		--print(cCount)
		--local point = scenario_derby_util.findRandomPoint()
		--local targetVec = (vec3(point) - vdataPos):normalized()
		--local dirTarget = dirVec:dot(targetVec)
		--if math.abs(dirTarget) > bestTargetVec then
			--targetList = "point" 
			--tdataPos = point
			--print("thepoint")
			--scenario_derby_vehicles.vehicleData[vNotToTarget].targetObj = point
		--end
		--cCount = cCount + 1 
		--scenario_derby_vehicles.vehicleData[vNotToTarget].cCount =  cCount
	--end
--	return targetList
	--		else 
		--		table.insert(targetList, vName)
	--			count = count + 1
	--		end
	--	end
	--end	
	--local j = nil
	--if count > 0 then
	--	j = tableChooseRandomKey(targetList)
	--	return targetList[j]
--	else
		--local cCount = scenario_derby_vehicles.vehicleData[vNotToTarget].cCount
		--if cCount > 0 then
		--[[
				for k, vName in pairs(sVehicles) do
					if vName ~= vNotToTarget and not vTimeout[vName] then
						if vehIn > 2 then
							if scenario_derby_main.stopTicks[vName] < 100 then 
								table.insert(targetList, vName)
							end
						else 
							table.insert(targetList, vName)
						end
					end
				end

				

				local j = nil
				j = tableChooseRandomKey(targetList)
				return targetList[j]--]]
		--else 
			
			--if dirTarget > 0.3 or dirTarget < -0.3 then
				--targetList = {["point"] = point}
			--	return targetList["point"]
			--	scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount + 1 
			--elseif not vTimeout[user] then
			--	targetList = user
			--	return targetList
			--else
			--	targetList = {["point"] = point}
			--	return targetList["point"]
			--	scenario_derby_vehicles.vehicleData[vNotToTarget].cCount = cCount + 1 
			--end
			
	--	end
		
	--end
end
-------------------------------------------------------------------------------------
--OBJECT TO AVOID BEHIND OR AHEAD 
-------------------------------------------------------------------------------------
--local function aiflee(t)
--	local tpos = nil
--		tpos = t 
--		local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tpos, vdata)
--		return dirDiff, dirTarget
--end
-------------------------------------------------------------------------------------
--GETS DIRECTION AND DISTANCE OF THE TARGET
-------------------------------------------------------------------------------------
local function aiPursuit(targetTemp)	
		local dir = map.objects[map.objectNames[vName]].dirVec
		local pos = map.objects[map.objectNames[vName]].pos
		local vel = map.objects[map.objectNames[vName]].vel
		local tpos = nil
		local tvel = vec3(0,0,0)
		if targetTemp == "point" or target == "point" or target == "line" then
			tpos = scenario_derby_vehicles.vehicleData[vName].targetObj
		else
			tpos = map.objects[map.objectNames[target]].pos
			tvel = map.objects[map.objectNames[target]].vel	
		end
		--debugDrawer:drawSphere(tpos:toPoint3F(), 0.5, ColorF(1,1,0,1))
		local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tpos, tvel, pos, dir, vel, dt)
		local curVel = tvel:length()
		local targetLength = math.max(curVel * 0.6, 8)
		local halfRemainder = targetLength * 0.5
		local vec = pos - tpos
		local vecLen = vec:length()
		local targetAiMidPos =  tpos + vec * math.min(halfRemainder,vecLen) / vecLen
		-- local targetVec = (tpos - vpos):normalized()
		 local aiDirVec = dir
		--local dirTarget = aiDirVec:dot(targetVec)
		--local vecUp = vdata.dirUp
		--local dirDiff = -math.asin(dirVec:cross(vec3(vecUp)):dot(targetVec))
		

		
		 --local dirDiff = math.asin(aiDirVec.x * targetVec.y - aiDirVec.y * targetVec.x)
		--debug(aiDirVec,targetAiMidPos, targetLength, dt, vName)
		--local futurePos = nil
		--if tdata.vel:length() > .01 then 
		--local vR = tdata.vel - vdata.vel
		--print(vR)
		--local sR = tdata.pos - vdata.pos
		--print(sR)
		--local sRMag = sR:length()
		--local vRMag = vR:length()
		--tC = sRMag / vRMag
		--print(tC)
		--futurePos = tdata.pos + (tdata.vel * tC)
		--futurePos.z = tdata.pos.z
	--	else 
		--local futurePos = (vdata.pos - tdata.pos):normalized()
		--futurePos.z = vdata.pos.z
		--local targetVec = (vdata.pos - tdata.pos):normalized()
		--end

		--debug(futurePos)
		
		--local dirVec = vdata.dirVec:normalized()
		--local dirDiff, dirTarget, dirVec = scenario_derby_util.vec2Diff(tpos, vdata)
		--local aiVel2Target = vec3(vdata.vel):dot((tpos - vdata.pos):normalized())
		--local aiTimeToTarget =  distance / speed  --(tdata.pos - vdata.pos):length() / (aiVel2Target + 1e-30)
		--local tspeed = tdata.vel:length()
		--local futurePos = tdataPos - vdataPos + vdataVel --aiTimeToTarget)
		--debug(futurePos)
		--local targetVec = futurePos:normalized()
		--local targetVec = (futurePos - vdataPos):normalized()
		--local check = vec3(targetVec)
		--debug(check)
		--targetVec = targetVec:normalized()
		--local targetVec = targetVec:normalized()
		--debugDrawer:drawSphere(targetVec:toPoint3F(), 4, ColorF(1,0,0,0.3))
		--debug(targetVec)
		--local dirTarget = dirVec:dot(targetVec)
	
		--debugDrawer:drawLine(vdata.pos:toPoint3F(), futurePos:toPoint3F(), ColorF(1,0,0,0.5))
		--local dirDiff = math.asin(dirVec.x * targetVec.y - dirVec.y * targetVec.x)
		--if dirDiff2 > 0 or dirDiff2 < 0 then
		--	dirDiff = dirDiff2
		--end
		return dirDiff, dirTarget
end
-------------------------------------------------------------------------------------
--RESET TARGET 
-------------------------------------------------------------------------------------
local function reset()
	targetSet = false
	target = nil
	--data.targetObj = {}
end
-------------------------------------------------------------------------------------
--CHECK IF WE ARE GONG TO HIT WALLS
-------------------------------------------------------------------------------------
local function wall()
	local wpNum1 = scenario_derby_main.wp1
	local wpNum2 = scenario_derby_main.wp2
	local wp1 = scenetree.findObject('wp_' ..wpNum1):getPosition()
	local wp2 = scenetree.findObject('wp_' ..wpNum2):getPosition()
	--debugDrawer:drawSphere(wp1:toPoint3F(), 0.5, ColorF(1,0,0,0.3))
	--debugDrawer:drawSphere(wp2:toPoint3F(), 0.5, ColorF(1,0,0,0.3))
	local vel = map.objects[map.objectNames[vName]].vel
	local pos = map.objects[map.objectNames[vName]].pos
	
	local speed = vel:length()	
	if speed < 1 then
		vel = vel * 1.9
	else 
		vel = vel * 1.3
	end
	local ahead = pos + vel
	--debugDrawer:drawLine(pos:toPoint3F(), ahead:toPoint3F(), 0.5, ColorF(1,0,0,0.5))
	--local result = nil
	local dx = nil
	local dy = nil
	local dz = nil
	local lineIntersect = nil
		dx, dy = scenario_derby_util.findIntersect(pos.x, pos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp1.x, wp2.y,true,true)
	if dx == false then
		dx, dy = scenario_derby_util.findIntersect(pos.x, pos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp2.x, wp1.y,true,true)
	end
	if dx == false then
		 dx, dy = scenario_derby_util.findIntersect(pos.x, pos.y, ahead.x,ahead.y, wp1.x, wp1.y, wp2.x, wp1.y,true,true)
	end
	if dx == false then
		dx, dy = scenario_derby_util.findIntersect(pos.x, pos.y, ahead.x,ahead.y, wp2.x, wp2.y, wp1.x, wp2.y,true,true)
	end

	
	if dx ~= false then
		dz = pos.z
		lineIntersect = vec3(dx, dy, dz)
		--print(lineIntersect)
		--debugDrawer:drawSphere(lineIntersect:toPoint3F(), 1.5, ColorF(1,0,0,1))
		return true, lineIntersect
	else
		return false, nil
	end
	
end
local function closest_point_on_seg(circle)
	local seg_b = map.objects[map.objectNames[vName]].vel
	local seg_a = map.objects[map.objectNames[vName]].pos
	local futurePos2 = seg_b + seg_a
	--debugDrawer:drawSphere(futurePos2:toPoint3F(), 0.5, ColorF(1,1,0,1))
	if seg_b:length() < 1 then
		seg_b = seg_b * 1
	else 
		seg_b = seg_b * 1.3
	end
	seg_b = seg_a + seg_b
			
			local closest = 0
		
			

			local seg_v = seg_b - seg_a 

			local pt_v = circle - seg_a
			if seg_v:length() <= 0 then return end
			local seg_v_unit = seg_v / seg_v:length()
			local proj = pt_v:dot(seg_v_unit)
			if proj <= 0 then
				 return seg_a
			elseif proj >= seg_v:length() then
				return seg_b
			else
				local proj_v = seg_v_unit * proj
				closest = proj_v + seg_a
				return closest
			end
			
end
-------------------------------------------------------------------------------------
--CHECKS FOR COLLISIONS WITH OBJECTS 
-------------------------------------------------------------------------------------
local function collisionCheck()
	local Arena = scenario_derby_main.Arena
	local dirDiff
	local dirTarget 
	--local targetVec
	--local vdata = map.objects[map.objectNames[vName]]
	--if target == "point" then
			--print(vName)
			--print(target["point"])
			--tdataPos = target["point"]
		--	tdataVel = vec3(0,0,0)
	--else 
	--	if not map.objects[map.objectNames[target]] then return end
	--	tdataPos = map.objects[map.objectNames[target]].pos
	--	tdataVel = map.objects[map.objectNames[target]].vel
	--end
	
	
	
	local result, line = wall()
	--print(result)
	--print(lineIntersect)
	if result == true then
		collision = true
		--debugDrawer:drawSphere(line:toPoint3F(), 0.5, ColorF(1,1,0,1))
		local point = nil
		if Arena == 1 then
			point = scenario_derby_vehicles.vehicleData[vName].startPos
		else
			local wpNum1 = scenario_derby_main.wp1
			local wpNum2 = scenario_derby_main.wp2
			local wp1 = scenetree.findObject('wp_' ..wpNum1):getPosition()
			local wp2 = scenetree.findObject('wp_' ..wpNum2):getPosition()
			local xpos = (wp1.x + wp2.x) / 2
			local ypos = (wp1.y + wp2.y) / 2
			local zpos = wp1.z
			point = vec3(xpos, ypos, zpos)
		end
		scenario_derby_vehicles.vehicleData[vName].targetObj = point
		--scenario_derby_vehicles.vehicleData[vName].line = line
		target = "line"
		targetSet = true
	end
   local circleOffset
   local targetTemp = nil
	if Arena == 1 then
			
			local cr = 7.5
			local cx = 157.99
			local cy = -198.1715
			local z = 58.55
			local circle = vec3(cx,cy, z)
			local offset = vec3(0,0,0)
			--debugDrawer:drawSphere(circle:toPoint3F(), cr, ColorF(1,0,0,0.3))
			--scenario_derby_vehicles.vehicleData[vName].targetTemp = nil
			


			local closest = closest_point_on_seg(circle)
			local dist_v = circle - closest
			local dist_c = dist_v:length()
			if dist_c > cr then
				if target ~= "point" and target ~= "line" then
					scenario_derby_vehicles.vehicleData[vName].targetObj = nil
				end
			elseif dist_c <= 0 then
			
			else
				local pos = map.objects[map.objectNames[vName]].pos
				local dx = pos.x - circle.x
				local dy = pos.y - circle.y
				local l = math.sqrt(dx * dx + dy * dy)
				local k = (cr * 2) / l
				offset.x = circle.x - dy * k
				offset.y = circle.y + dx * k
				offset.z = circle.z
				print(dist_c)
				--offset = dist_v /dist_c * (cr - dist_c)
				--local t = offset + circle
				--debugDrawer:drawSphere(offset:toPoint3F(), 0.5, ColorF(1,1,1,1))
				scenario_derby_vehicles.vehicleData[vName].targetObj = offset
				targetTemp = "point"
			end
	end
	dirDiff, dirTarget = aiPursuit(targetTemp)
	return dirDiff, dirTarget
	
end
-------------------------------------------------------------------------------------
--CHANGES THE DIRECTION FOR FORWARE TO BACKWARDS
-------------------------------------------------------------------------------------
local function changeDir()
	if backup == false then
		backup = true
	else 
		backup = false
	end
end
-------------------------------------------------------------------------------------
--SETS THE COUNT FOR HOW LONG WE GO FORWARD OR BACKWARDS
-------------------------------------------------------------------------------------
local function counts(dirTarget)
	local lCount = scenario_derby_vehicles.vehicleData[vName].lCount
	local dtCount = scenario_derby_vehicles.vehicleData[vName].dtCount
	local pos = map.objects[map.objectNames[vName]].pos
	local tpos = nil
	if target == "point" or target == "line" then
		tpos = scenario_derby_vehicles.vehicleData[vName].targetObj
	else
		tpos = map.objects[map.objectNames[target]].pos
	end
	--print(lCount .."lCount " ..dtCount .. "dtCount")
	if collision == false then					
		if lasthit == true then
			if lCount == 1 then 
				changeDir()
			end
			local hDist = vec3(pos):distance(vec3(tpos))
			if lCount > 100 or hDist > 10 then
				if hitTarget == true then
					reset()
					hitTarget = false
					scenario_derby_vehicles.vehicleData[vName].cCount = 0
				end
				lasthit = false
				lCount = 0
				--cCount = 0
			else
				lCount = lCount + 1
			end
		else
			if target == "point" then
				local pDist = vec3(pos):distance(vec3(tpos))
				if pDist < 14 then
					dtCount = 0 
					lCount = 0
					reset()
				end
			end
			if dtCount < 400 then	
				dtCount = dtCount + 1 
				if dirTarget < 0 then
					backup = true
				else
					backup = false	
				end
			else
				dtCount = 0
				lCount = 0
				reset()
				--scenario_derby_vehicles.vehicleData[vName].cCount = 0
			end
		end
	else
		--local point = scenario_derby_vehicles.vehicleData[vName].targetObj
		--local line = scenario_derby_vehicles.vehicleData[vName].line
		--local dirChange = scenario_derby_vehicles.vehicleData[vName].dirChange
		--local lDist = 0
		--local dirLine = nil
		local lDist = vec3(pos):distance(vec3(tpos))
		--if line ~= nil then
			--local dirVec = map.objects[map.objectNames[vName]].dirVec
			--local targetVec = (line - pos):normalized()
			--dirLine = dirVec:dot(targetVec)
		--	lDist = vec3(pos):distance(vec3(line))
		--end
		--print(tDist)
		if lDist < 20 then
			reset()
			collision = false 
			--scenario_derby_vehicles.vehicleData[vName].line = nil
			brake = 0 
			throttle = 0 
			--local startPos = scenario_derby_vehicles.vehicleData[vName].startPos
			--	local sDist = vec3(pos):distance(vec3(point))
			--	if sDist < 15 then
					--target = "point"
					--scenario_derby_vehicles.vehicleData[vName].targetObj = startPos
			--	else
			--		scenario_derby_vehicles.vehicleData[vName].cCount = 0
			--	end
			--dirChange = false
		else
			local stopTicks = scenario_derby_main.stopTicks[vName]
			if stopTicks > 150 and stopTicks < 401 then
				if  stopTicks == 151 or stopTicks == 400 then
					changeDir()
				end
			else
					if dirTarget < 0 then
						backup = true
						throttle = 0
						brake = .7
						if lDist < 15 then
							brake = 0.3	
						end
					else 
						backup = false
						brake = 0
						throttle = .8 
						if lDist < 15 then
							throttle = .3
						end
					end
				end
			--scenario_derby_vehicles.vehicleData[vName].dirChange = dirChange
		end
	end

	scenario_derby_vehicles.vehicleData[vName].lCount = lCount
	scenario_derby_vehicles.vehicleData[vName].dtCount = dtCount
end
-------------------------------------------------------------------------------------
-- AI CODE
-------------------------------------------------------------------------------------
local function update(idName, dt)	
		vName = idName
	if not scenario_derby_vehicles.vehicleData[vName] then return end
	 targetSet = scenario_derby_vehicles.vehicleData[vName].targetSet
	 hitTarget =  scenario_derby_vehicles.vehicleData[vName].hitTarget
	 lasthit = scenario_derby_vehicles.vehicleData[vName].lasthit
	 backup = scenario_derby_vehicles.vehicleData[vName].backup
	 brake = scenario_derby_vehicles.vehicleData[vName].brake
	 throttle = scenario_derby_vehicles.vehicleData[vName].throttle
	 collision = scenario_derby_vehicles.vehicleData[vName].collision
	 target = scenario_derby_vehicles.vehicleData[vName].target
	--if we don't have a target find one
	if not target then target = user end
	if targetSet ~= true then
		findRandomTarget(vName)  --find a random target
		--targetObj = scenetree.findObject(target)
		targetSet = true
	else
		--print(target)
		 --Update Data		
		--map.objects returns objId, isactive, pos, vel, dirVec, dirVecUp, damage, objectCollisions
			--tdata = map.objects[map.objectNames[target]]
			
		--if target["point"] then
			--print(vName)
			--print(target["point"])
			--tdata.pos = target["point"]
			--tdata.vel = vec3(0,0,0)
		--else 
	
		local aiCollisions = map.objects[map.objectNames[vName]].objectCollisions
			--local targetObj = scenetree.findObject(target)
			--local targetID = targetObj.obj:getID()  --get target id
		local targetID = nil
		if target == "point" or target == "line"  then		
		else 
			local to = scenetree.findObject(target)
			if to.obj and to.obj:getID() then
				targetID = to.obj:getID()
			end
		end
		--dump(aiCollisions)
		--print(targetID)
			if aiCollisions ~= nil then
				--dump (aiCollisions)
				for k,v in pairs (aiCollisions) do
					--if targetID then print(k.." "..targetID) end
					if k == targetID then		
						hitTarget = true
					else
						hitTarget = false
					end			 
					if not scenario_derby_vehicles.sVehiclesID[k] then
						--print(k)

					else
						lasthit = true
					end 
					
				end	
			end
		local dirDiff, dirTarget = collisionCheck()
		--if collision == false and lasthit == true then
			--dirDiff = 0 
		--end
		local bt = nil 
		--local wheelSlip = scenario_derby_wheels.slipHigh()
		counts(dirTarget)
		local vel = map.objects[map.objectNames[vName]].vel
		local pos = map.objects[map.objectNames[vName]].pos
		if collision == false then
			if backup == true  then
				bt = scenario_derby_vehicles.adjustBrakeThrottle(brake,vel, dirTarget)
				throttle = 0
				brake = bt
			else
				bt = scenario_derby_vehicles.adjustBrakeThrottle(throttle,vel, dirTarget)
				brake = 0 
				throttle = bt
			end
		end
	--	if brake > 0 then
		--	pos.y = pos.y - brake
		--	debugDrawer:drawSphere(pos:toPoint3F(), 0.5, ColorF(1,1,1,1))
		--else
		--	pos.y = pos.y + throttle
		--	debugDrawer:drawSphere(pos:toPoint3F(), 0.5, ColorF(1,1,0,1))
	--	end
		
		--print(collision)
		--print("collision")
		
		
		
		--print(backup)
		--print("backup")
		--print(hitTarget)
		--print("hitTarget") 
		--print(lasthit) 
		--print("lasthit")
		--print(dirTarget.. "dirTarget ".. dirDiff .. "dirDiff ")
		--guihooks.trigger('DerbyPlaceChange', { one = dirTarget, two = throttle, three = brake} )	
		--local vObj = scenetree.findObject(vName)
		--if collision == true then 
		--	vObj:queueLuaCommand('input.event("throttle", '..throttle..', 2)')
		--	vObj:queueLuaCommand('input.event("brake", '..brake..', 2)')
		--end
		
		
		--if vObj then
		--	vObj:queueLuaCommand('input.event("steering", '..-dirDiff..', 1)')
		--end
		--print("throttle".. throttle.. "brake ".. brake.. " " .. vName .. " " ..target.."")
		scenario_derby_vehicles.driveCar(vName,-dirDiff,throttle,brake,0)
		
		
	end
	scenario_derby_vehicles.vehicleData[vName].target = target
	scenario_derby_vehicles.vehicleData[vName].targetSet = targetSet 
	scenario_derby_vehicles.vehicleData[vName].hitTarget = hitTarget
	scenario_derby_vehicles.vehicleData[vName].lasthit = lasthit
	scenario_derby_vehicles.vehicleData[vName].backup = backup
	scenario_derby_vehicles.vehicleData[vName].brake = brake
	scenario_derby_vehicles.vehicleData[vName].throttle = throttle
	scenario_derby_vehicles.vehicleData[vName].collision = collision
end

M.update = update


return M